package mdd.client;

import javafx.scene.shape.Line;
import org.json.simple.JSONObject;


public class Connection extends Line implements IGUIEventClient {
    private GUIEventHandler _eventHandler = new GUIEventHandler();
    private Input _in;
    private Output _out;

    public Connection(Input in, Output out){
        super(0,0,100,100);
        _in = in;
        _out = out;
        System.out.println("Connection: "+ in.x.toString());
        this.startXProperty().bind(in.x);
        this.startYProperty().bind(in.y);

        this.endXProperty().bind(out.x);
        this.endYProperty().bind(out.y);

        in.setConnected(true);
        out.setConnected(true);
    }

    @Override
    public GUIEventHandler getGUIEventHandler() {
        return _eventHandler;
    }

    @Override
    public void setGUIEventHandler(GUIEventHandler eventHandler) {
        _eventHandler = eventHandler;
    }

    @Override
    public void processGUIEvent(String event, JSONObject args) {

    }
}
